//OCX Implementation of "RSA Data Security, Inc. MD5 Message-Digest Algorithm"
//This software is "derived from the RSA Data Security, Inc. MD5 Message-Digest Algorithm"
//For More Information see the Original Package "RFC1321_SourceFiles.zip"

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
   rights reserved.

   License to copy and use this software is granted provided that it
   is identified as the "RSA Data Security, Inc. MD5 Message-Digest
   Algorithm" in all material mentioning or referencing this software
   or this function.

   License is also granted to make and use derivative works provided
   that such works are identified as "derived from the RSA Data
   Security, Inc. MD5 Message-Digest Algorithm" in all material
   mentioning or referencing the derived work.  
                                                                    
   RSA Data Security, Inc. makes no representations concerning either
   the merchantability of this software or the suitability of this
   software for any particular purpose. It is provided "as is"
   without express or implied warranty of any kind.  
                                                                    
   These notices must be retained in any copies of any part of this
   documentation and/or software.  
 */

#if !defined(AFX_MD5OCXCTL_H__B69DD5E2_73A6_40F5_8650_44894152C6D4__INCLUDED_)
#define AFX_MD5OCXCTL_H__B69DD5E2_73A6_40F5_8650_44894152C6D4__INCLUDED_

//mod+
#include "MD5OCXGlobal.h"       // main symbols
typedef struct {
  UINT4 state[4];                                   /* state (ABCD) */
  UINT4 count[2];        /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                         /* input buffer */
} MD5_CTX;
//mod-

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// MD5OCXCtl.h : Declaration of the CMD5OCXCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CMD5OCXCtrl : See MD5OCXCtl.cpp for implementation.

class CMD5OCXCtrl : public COleControl
{
	DECLARE_DYNCREATE(CMD5OCXCtrl)

// Constructor
public:
	CMD5OCXCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMD5OCXCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual DWORD GetControlFlags();
	//}}AFX_VIRTUAL

	//mod+
	MD5_CTX context;	
	void MD5Init (MD5_CTX *context);
	void MD5Update (MD5_CTX *context,unsigned char *input,unsigned int inputLen);
	void MD5Final (unsigned char digest[16],MD5_CTX *context);
	void MD5Transform (UINT4 state[4],unsigned char block[64]);
	void Encode (unsigned char *output,	UINT4 *input,unsigned int len);
	void Decode (UINT4 *output,	unsigned char *input,unsigned int len);
	void MD5_memcpy (POINTER output,POINTER input,unsigned int len);
	void MD5_memset (POINTER output,int value,unsigned int len);
	//mod-

// Implementation
protected:
	~CMD5OCXCtrl();

	DECLARE_OLECREATE_EX(CMD5OCXCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CMD5OCXCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CMD5OCXCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CMD5OCXCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CMD5OCXCtrl)
		// NOTE - ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CMD5OCXCtrl)
	afx_msg BSTR CodeMD5(LPCTSTR param);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

// Event maps
	//{{AFX_EVENT(CMD5OCXCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CMD5OCXCtrl)
	dispidCodeMD5 = 1L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MD5OCXCTL_H__B69DD5E2_73A6_40F5_8650_44894152C6D4__INCLUDED)
